CON

  { ==[ CLOCK SET ]== }
  _CLKMODE      = XTAL1 + PLL16X
  _XINFREQ      = 5_000_000    

  array_len = 300
  

OBJ

  MEM   : "MEM_store-read-long-arrays"
  DEBUG : "DEBUG"

VAR

  LONG  v[array_len]            ' value to be stored
  LONG  r[array_len]            ' value to be returned

PUB Main | i, write_to_addr, el_size_exp

  DEBUG.start_baud(115_200)
  waitcnt(clkfreq + cnt)
  DEBUG.clr

  { Values }
  write_to_addr := $1000        ' this is the EEPROM address that the value is written and read from (storing is not length limited)
  el_size_exp := 2              ' element size multiplier, 0 = byte, 1 = word, 2 = long (could be hard coded, but this just makes it easier to experiment)

  { Setup }
  DEBUG.str(string("Clear Result",$D))
  longfill(@r, 0, array_len)                            ' clear results array just to "make sure"
  REPEAT i FROM 0 TO constant(array_len - 1)
    v[i] := i + 1000                                    ' populate array to be stored


  { The Real Stuff }
  DEBUG.str(string("Init",$D))
  MEM.init

  DEBUG.str(string("Write",$D))
  MEM.write_multipage(write_to_addr, @v, array_len << el_size_exp) ' write array

  DEBUG.str(string("Read",$D))
  bytemove(@r, MEM.read_multipage(write_to_addr, array_len << el_size_exp), array_len << el_size_exp) ' read array -- for safety, immediately move it to a variable in this object

  DEBUG.str(string("Done.",$D,"Read Results:",$D))
  DEBUG.arrDec(@r, array_len, 1 << el_size_exp, true)   ' display results


  { Do other stuff }
  REPEAT
    waitcnt(0)